#define AppVersion "1.0.4"
#define ExpirationYear "2009"
#define ExpirationMonth "12"

#define AppName "UltraVnc"
#define AppPublisher "UltraVnc"
#define filename "Ultravnc_tools_Setup"
#define AppID "Ultravnc2"

#define SetupDriver "setupdrv.exe"
#define Servicename "Uvnc_service"
#define AppServiceExe "uvnc_service.exe"


[Setup]
AppName={cm:MyAppName}
AppVerName={cm:MyAppVerName,v{#AppVersion}}
AppVersion={#AppVersion}
VersionInfoVersion={#AppVersion}
AppPublisher={#AppPublisher}
AppCopyright={#AppPublisher}
AppPublisherURL={cm:PublisherURL}
AppSupportURL={cm:SupportURL}
AppUpdatesURL={cm:UpdatesURL}
DefaultDirName={pf}\{cm:MyAppName}
DefaultGroupName={cm:MyAppName}
WindowVisible=false
DisableStartupPrompt=true
DisableReadyPage=true
ChangesAssociations=true
MinVersion=0,5.0.2195
PrivilegesRequired=admin
AppID={#AppID}
UninstallRestartComputer=true
DirExistsWarning=no
OutputDir=setupfile
OutputBaseFilename={#filename}
BackColorDirection=lefttoright
UserInfoPage=false
ShowLanguageDialog=true
LanguageDetectionMethod=uilanguage
AllowUNCPath=false
WindowShowCaption=false
WindowStartMaximized=false
WindowResizable=false
Compression=bzip
AlwaysRestart=false
VersionInfoDescription={#AppName} Setup
WizardImageBackColor=clWhite
WizardImageStretch=no
SetupIconFile=UltraVNC.ico
WizardImageFile=UltraVNC-splash.bmp
WizardSmallImageFile=UltraVNC-logo.bmp
CreateUninstallRegKey=false
UpdateUninstallLogAppName=false
LicenseFile=Readme-Licence.txt
InfoAfterFile=info.txt

[Languages]
Name: en; MessagesFile: compiler:Default.isl
Name: de; MessagesFile: compiler:Languages\german.isl
Name: fr; MessagesFile: compiler:Languages\french.isl
Name: it; MessagesFile: compiler:Languages\Italian.isl
Name: es; MessagesFile: compiler:Languages\spanish.isl

[CustomMessages]
en.driverinstallmsg=Installing video driver. Screen flicker is normal.
en.MyAppName={#AppName}
en.MyAppVerName={#AppName} %1
en.serviceinstall=Service is being installed...
en.servicestart=Service is now being started...
en.serviceuninstall=Service is being uninstalled...
en.updateserviceuninstall=Uninstalling existing Service...
en.servicestop=Service is being stopped...
en.SupportURL=http://forum.ultravnc.info
en.UpdatesURL=http://www.uvnc.com
en.PublisherURL=http://www.uvnc.com

de.driverinstallmsg=Der Videotreiber wird installiert. Bildschirmflackern ist normal.
de.MyAppName={#AppName}
de.MyAppVerName={#AppName} %1
de.serviceinstall=Fernsteuerungsdienst wird installiert...
de.servicestart=Fernsteuerungsdienst wird gestartet...
de.serviceuninstall=Fernsteuerungsdienst wird deinstalliert...
de.updateserviceuninstall=Deinstalliere existierenden Fernsteuerungsdienst...
de.servicestop=Fernsteuerungsdienst wird gestoppt...
de.SupportURL=http://forum.ultravnc.info
de.UpdatesURL=http://www.uvnc.com
de.PublisherURL=http://www.uvnc.com

en.FullInstall=Full installation
de.FullInstall=Vollstndige Installation
fr.FullInstall=Installation complte

en.CustomInstall=Custom installation
de.CustomInstall=Benutzerdefinierte Installation
fr.CustomInstall=Installation personnalise

en.ServiceOnly=UltraVnc Service Only
de.ServiceOnly=Nur UltraVnc Service
fr.ServiceOnly=Seulement UltraVnc service

en.DriverOnly=UltraVnc Mirror Driver Only
de.DriverOnly=Nur UltraVnc Mirror Driver
fr.DriverOnly=Seulement UltraVnc Mirror Driver

[Types]
Name: full; Description: {cm:FullInstall}
Name: serv; Description: {cm:ServiceOnly}
Name: driver; Description: {cm:DriverOnly}
Name: custom; Description: {cm:CustomInstall}; Flags: iscustom

[Components]
Name: UltraVnc_Service; Description: UltraVnc Service; Types: full serv; Flags: disablenouninstallwarning
Name: UltraVnc_mirror_Driver; Description: UltraVNC Mirror Driver; Types: full driver; Flags: disablenouninstallwarning; MinVersion: 0,5.0.2195


[Tasks]
;Name: userstartupicon; Description: {cm:autostart}

[Files]
Source: Readme-Licence.txt; DestDir: {app}; Components: UltraVnc_Service
Source: uvnc_service.exe; DestDir: {app}; Components: UltraVnc_Service
Source: schook.dll; DestDir: {app}; Components: UltraVnc_Service
Source: cad.exe; DestDir: {app}; Components: UltraVnc_Service
Source: install_service.exe; DestDir: {app}; Components: UltraVnc_Service
Source: start_service.exe; DestDir: {app}; Components: UltraVnc_Service
Source: stop_service.exe; DestDir: {app}; Components: UltraVnc_Service
Source: uninstall_service.exe; DestDir: {app}; Components: UltraVnc_Service
Source: driver\vista\mv2.sys; DestDir: {app}\driver\; Flags: ignoreversion; Check: IsVista ; Components: UltraVnc_mirror_Driver
Source: driver\vista\mv2.cat; DestDir: {app}\driver\; Flags: ignoreversion; Check: IsVista ; Components: UltraVnc_mirror_Driver
Source: driver\vista\mv2.dll; DestDir: {app}\driver\; Flags: ignoreversion; Check: IsVista ; Components: UltraVnc_mirror_Driver
Source: driver\vista\mv2.inf; DestDir: {app}\driver\; Flags: ignoreversion; Check: IsVista  ; Components: UltraVnc_mirror_Driver
Source: driver\xp\mv2.sys; DestDir: {app}\driver\; Flags: ignoreversion; Check: NOT IsVista  ; Components: UltraVnc_mirror_Driver
Source: driver\xp\mv2.cat; DestDir: {app}\driver\; Flags: ignoreversion; Check: NOT IsVista  ; Components: UltraVnc_mirror_Driver
Source: driver\xp\mv2.dll; DestDir: {app}\driver\; Flags: ignoreversion; Check: NOT IsVista   ; Components: UltraVnc_mirror_Driver
Source: driver\xp\mv2.inf; DestDir: {app}\driver\; Flags: ignoreversion; Check: NOT IsVista  ; Components: UltraVnc_mirror_Driver
Source: driver\setupdrv.exe; DestDir: {app}\; Flags: ignoreversion ; Components: UltraVnc_mirror_Driver
Source: driver\install.bat; DestDir: {app}; Components: UltraVnc_mirror_Driver
Source: driver\install_silent.bat; DestDir: {app}; Components: UltraVnc_mirror_Driver
Source: driver\license.txt; DestDir: {app}; Components: UltraVnc_mirror_Driver
Source: driver\uninstall.bat; DestDir: {app}; Components: UltraVnc_mirror_Driver
Source: driver\uninstall_silent.bat; DestDir: {app}; Components: UltraVnc_mirror_Driver
Source: info.txt; DestDir: {app}; Components: UltraVnc_Service


[Icons]
Name: {group}\Stop Service; FileName: {app}\stop_service.exe; WorkingDir: {app}; Components: UltraVnc_Service
Name: {group}\Start Service; FileName: {app}\start_service.exe; WorkingDir: {app}; Components: UltraVnc_Service
Name: {group}\Uninstall Service; FileName: {app}\uninstall_service.exe; WorkingDir: {app}; Components: UltraVnc_Service
Name: {group}\Install Service; FileName: {app}\install_service.exe; WorkingDir: {app}; Components: UltraVnc_Service

Name: {group}\Uninstall Driver; FileName: {app}\driver\uninstall.bat; WorkingDir: {app}; Components: UltraVnc_mirror_Driver
Name: {group}\Install Driver; FileName: {app}\driver\install.bat; WorkingDir: {app}; Components: UltraVnc_mirror_Driver

Name: {group}\{cm:UninstallProgram,{cm:MyAppName}}; Filename: {uninstallexe}


[Registry]
Root: HKLM; Subkey: SYSTEM\CurrentControlSet\Hardware Profiles\Current\System\CurrentControlSet\Services\mv2\DEVICE0; Permissions: authusers-full; ValueType: dword; ValueName: Attach.ToDesktop; ValueData: 0; Flags: uninsdeletekey
Root: HKLM; Subkey: SYSTEM\CurrentControlSet\Services\vmv2\Device0; Permissions: authusers-full; ValueType: dword; ValueName: Acceleration.Level; ValueData: 0; Flags: uninsdeletekey

[Run]
;Stop any existing service first in case of update...
Filename: {app}\{#SetupDriver}; Description: Install virtual driver; Parameters: install; StatusMsg: {cm:driverinstallmsg}; Components: UltraVnc_mirror_Driver
Filename: {sys}\net; Parameters: "stop ""{#Servicename}"""; WorkingDir: {app}; Flags: runminimized; StatusMsg: {cm:servicestop}; check: IsServiceInstalled; Components: UltraVnc_Service

; Better with -silent if supported...
Filename: {app}\uninstall_service.exe; WorkingDir: {app}; Flags: runminimized; StatusMsg: {cm:updateserviceuninstall}; check: IsServiceInstalled; Components: UltraVnc_Service
Filename: {app}\install_service.exe; WorkingDir: {app}; Flags: runminimized; StatusMsg: {cm:serviceinstall}; Components: UltraVnc_Service
Filename: {app}\start_service.exe; WorkingDir: {app}; Flags: runminimized; StatusMsg: {cm:servicestart}; Components: UltraVnc_Service

[UninstallRun]
Filename: {app}\stop_service.exe; WorkingDir: {app}; Flags: runminimized; StatusMsg: {cm:servicestop}; Components: UltraVnc_Service
Filename: {app}\uninstall_service.exe; WorkingDir: {app}; Flags: runminimized; StatusMsg: {cm:serviceinstall}; Components: UltraVnc_Service
Filename: {app}\{#SetupDriver}; Flags: waituntilterminated; Parameters: uninstall; Components: UltraVnc_mirror_Driver

[Code]
var
  update:Boolean;

//Required, because, otherwise the uninstall registry key changes over installation time
function IsUpdate() : boolean;
begin
  Result := update;
end;

function IsServiceInstalled() : boolean;
begin
  Result := RegKeyExists(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Services\{#Servicename}');
end;

//Check whether Vista is used
function IsVista():Boolean;
var
  Version: TWindowsVersion;
begin
  Result:=False;
  GetWindowsVersionEx(Version);
  if Version.NTPlatform and (Version.Major = 6) then Result:=True;
end;
